/**************************************************************************//**
 * @item     CosyOS Config
 * @file     mcucfg_80251.h
 * @brief    80251 Core Config File
 * @author   ٿ
 * @version  V2.3.5
 * @date     2023.05.10
 ******************************************************************************/

#ifndef __MCUCFG_80251_H
#define __MCUCFG_80251_H

/******************************************************************************
 *                             USER Definitions                               *
 ******************************************************************************/

          //*** <<< Use Configuration Wizard in Context Menu >>> ***//

///////////////////////////////////////////////////////////////////////////////
// <h> 
// <i> 

// <o> Code Rom Size
// <0=> Large <1=> Huge
// <i> Ҫʵñһ£CosyOS޷С
#define SYSCFG_CODEROMSIZE              0

// <q> 4 Byte Interrupt Frame Size
// <i> Ҫʵñһ£CosyOS޷С
#define SYSCFG_4BYTEINTFRAME            1

// </h>
///////////////////////////////////////////////////////////////////////////////
// <s> ׼ͷļ
// <i> MCUƥı׼ͷļcļпɲٰļ
// <i> ʾһSTC32G.H
// <i> ʾ..\MCU\STC32G.Hְ·дͼûʱʱ⣬ı༭жǿУԡ
#define MCUCFG_STANDARDHEAD             "STC32G.H"
///////////////////////////////////////////////////////////////////////////////
// <o> ϵͳʱ
// <i> ֪CosyOSõϵͳʱӣλΪMHZ
#define MCUCFG_SYSFOSC                  24
#if !MCUCFG_SYSFOSC
#error Ƿֵ
#endif
///////////////////////////////////////////////////////////////////////////////
// <o> ϵͳʱӷƵϵ
// <i> ֪CosyOSõϵͳʱӷƵϵȡֵΧ<1~255>
#define MCUCFG_SYSFOSCDIV               1
#if !MCUCFG_SYSFOSCDIV
#error Ƿֵ
#endif
///////////////////////////////////////////////////////////////////////////////
// <o> ջڴ
// <0=> idata <1=> edata
// <i> MCUedataڴ棬ӦջڴΪedataӦջڴΪidata
#define __MCUCFG_STACKMEM               1
#if __MCUCFG_STACKMEM == 0
#define _STACK_MEM_                     idata
#else
#define _STACK_MEM_                     edata
#endif
///////////////////////////////////////////////////////////////////////////////
// <h> ջģʽ
// <i> ջģʽΪMSPģʽMSP+PSPģʽ˫ջָģʽֻѡһ
// <i> MSPģʽ51ƬջģʽͬлʱҪݵģЧʵͣͬʱȴӵ100%ɿջطƣֻҪջڴ㹻Ϳȷջ
// <i> MSP+PSPģʽлЧʵͬCortex-Mÿջջ㹻edataڴ档
// <i> MCUedataڴ㹻󣬿ԿMSP+PSPģʽлЧʡ

// <e> MSPģʽ
// <i> ǷMSPģʽ
#define __MCUCFG_MSPMODE                0
// <o> ȼжϼĴ
// <0=> bank0 <1=> bank1 <2=> bank2 <3=> bank3
// <i> ȼжϵļĴ⣬bank0ΪʹöļĴ⡣
#define MCUCFG_STKREGBANK               0
// </e>

// <e> MSP+PSPģʽ
// <i> ǷMSP+PSPģʽ˫ջָģʽ
#define __MCUCFG_MSPPSPMODE             1

#if   __MCUCFG_MSPMODE == 1 && __MCUCFG_MSPPSPMODE == 0
#define MCUCFG_TASKSTACKMODE            __MSP__
#elif __MCUCFG_MSPMODE == 0 && __MCUCFG_MSPPSPMODE == 1
#define MCUCFG_TASKSTACKMODE            __MSP_PSP__
#elif __MCUCFG_MSPMODE == 0 && __MCUCFG_MSPPSPMODE == 0
#error ջģʽδ壡
#elif __MCUCFG_MSPMODE == 1 && __MCUCFG_MSPPSPMODE == 1
#error ջģʽض壡
#endif

#if MCUCFG_TASKSTACKMODE == __MSP_PSP__

// <o> ջС
// <i> min45
#define __STACKSIZE_TASKMGR__           100
#if __STACKSIZE_TASKMGR__ < 45
#error Ƿֵ
#endif

// <o> ϵͳջС
// <i> min42
#define __STACKSIZE_DEBUGGER__          100
#if __STACKSIZE_DEBUGGER__ < 42
#error Ƿֵ
#endif

// <o> ϵͳջС
// <i> min42
#define __STACKSIZE_STARTER__           100
#if __STACKSIZE_STARTER__ < 42
#error Ƿֵ
#endif

// <o> ϵͳջС
// <i> min42
#define __STACKSIZE_SYSIDLE__           100
#if __STACKSIZE_SYSIDLE__ < 42
#error Ƿֵ
#endif

// <q> ջ
// <i> Ƿջأ
// <i> CosyOSԶջشÿһϵͳĿʼ
// <i> Ӧܵİջش뵽ÿһõԶ庯ڣΪĵһ롣
// <i> ȻҲ޷ʵ100%ɿջأΪȻһֺ޷ջش룬׼⺯
// <i> ֻҪջش룬׼ȷжϳڴ˺Ƿջķա
// <i> ڵԽ׶οܣʽĲƷӦá
#define MCUCFG_TASKSTACKMONITOR         1

#endif
// </e>
// </h>
///////////////////////////////////////////////////////////////////////////////
// <h> PendSV_Handler
// <i> 251ƬûPendSV_HandlerжϣӦרһӲжڴPendSV_Handler
// <i> ѡһδʹõӲжϣڳʼעȼӦΪͼ

// <o> жϺ
// <i> жϺ
#define MCUCFG_PSVIRQ                   0

// <o> жϹر
// <i> Ӧı༭ж塣
// <i> ʾEX0 = 0
#define mPSV_Disable                    EX0 = 0

// <o> жϿ
// <i> Ӧı༭ж塣
// <i> ʾEX0 = 1
#define mPSV_Enable                     EX0 = 1

// <o> жϴ
// <i> жϱ־λ
// <i> Ӧı༭ж塣
// <i> ʾIE0 = 1
#define mPSV_Trigger                    IE0 = 1

// <o> ж
// <i> жϱ־λ
// <i> Ӧı༭ж塣
// <i> ʾIE0 = 0
#define mPSV_Clear                      IE0 = 0

// <o> 첽
// <i> ȡֵΧ<2~64>
// <i> 251Ƭжÿһ첽񣬶ҪһΨһķIDڶже첽ܴ
// <i> ʾ첽Ϊ10ôжֻܵ10첽񣬷IDΪ0~9
#define MCUCFG_ISVTOTAL                 2
#if MCUCFG_ISVTOTAL < 2 || MCUCFG_ISVTOTAL > 64
#error Ƿֵ
#endif

// </h>
///////////////////////////////////////////////////////////////////////////////
// <h> ڴŻ
// <i> ڴŻΪûһϵͳĴ洢Դﵽѵڴʺ;ܵܡ
// <i> ÿһӦܵΪܵڴ档

// <o> ʱжڴ
// <0=> data <1=> edata <2=> idata <3=> pdata <4=> xdata
// <i> ʱжڴ
#define __MCUCFG_MEMOPT1                1
#if   __MCUCFG_MEMOPT1 == 0
#define _TIMINT_MEM_                    data
#elif __MCUCFG_MEMOPT1 == 1
#define _TIMINT_MEM_                    edata
#elif __MCUCFG_MEMOPT1 == 2
#define _TIMINT_MEM_                    idata
#elif __MCUCFG_MEMOPT1 == 3
#define _TIMINT_MEM_                    pdata
#elif __MCUCFG_MEMOPT1 == 4
#define _TIMINT_MEM_                    xdata
#endif

// <o> ʱѯڴ
// <0=> data <1=> edata <2=> idata <3=> pdata <4=> xdata
// <i> ʱѯڴ
#define __MCUCFG_MEMOPT2                1
#if   __MCUCFG_MEMOPT2 == 0
#define _TIMQRY_MEM_                    data
#elif __MCUCFG_MEMOPT2 == 1
#define _TIMQRY_MEM_                    edata
#elif __MCUCFG_MEMOPT2 == 2
#define _TIMQRY_MEM_                    idata
#elif __MCUCFG_MEMOPT2 == 3
#define _TIMQRY_MEM_                    pdata
#elif __MCUCFG_MEMOPT2 == 4
#define _TIMQRY_MEM_                    xdata
#endif

// <o> DEBUGڴ
// <0=> data <1=> edata <2=> idata <3=> pdata <4=> xdata
// <i> DEBUGڴ
#define __MCUCFG_MEMOPT31               1
#if   __MCUCFG_MEMOPT31 == 0
#define _DEBUG_HMEM_                    data
#elif __MCUCFG_MEMOPT31 == 1
#define _DEBUG_HMEM_                    edata
#elif __MCUCFG_MEMOPT31 == 2
#define _DEBUG_HMEM_                    idata
#elif __MCUCFG_MEMOPT31 == 3
#define _DEBUG_HMEM_                    pdata
#elif __MCUCFG_MEMOPT31 == 4
#define _DEBUG_HMEM_                    xdata
#endif

// <o> DEBUGڴ
// <0=> data <1=> edata <2=> idata <3=> pdata <4=> xdata
// <i> DEBUGڴ
#define __MCUCFG_MEMOPT32               1
#if   __MCUCFG_MEMOPT32 == 0
#define _DEBUG_MMEM_                    data
#elif __MCUCFG_MEMOPT32 == 1
#define _DEBUG_MMEM_                    edata
#elif __MCUCFG_MEMOPT32 == 2
#define _DEBUG_MMEM_                    idata
#elif __MCUCFG_MEMOPT32 == 3
#define _DEBUG_MMEM_                    pdata
#elif __MCUCFG_MEMOPT32 == 4
#define _DEBUG_MMEM_                    xdata
#endif

// <o> DEBUGڴ
// <0=> edata <1=> xdata
// <i> DEBUGڴ
#define __MCUCFG_MEMOPT33               1
#if   __MCUCFG_MEMOPT33 == 0
#define _DEBUG_LMEM_                    edata
#elif __MCUCFG_MEMOPT33 == 1
#define _DEBUG_LMEM_                    xdata
#endif

// <o> ̬ڴ
// <0=> edata <1=> xdata
// <i> ̬ڴ
#define __MCUCFG_MEMOPT4                0
#if   __MCUCFG_MEMOPT4 == 0
#define _TASK_MEM_                      edata
#elif __MCUCFG_MEMOPT4 == 1
#define _TASK_MEM_                      xdata
#endif

// </h>
///////////////////////////////////////////////////////////////////////////////
// <h> ̬ڴ
// <i> CosyOSʹвԶʼڴء

// <o> ڴָ
// <i> ڴصʼڴַ
#define MCUCFG_MALLOCMEMBPTR            1800
#if !MCUCFG_MALLOCMEMBPTR
#error Ƿֵ
#endif

// <o> ڴشС
// <i> ڴصĴСֽ
#define MCUCFG_MALLOCMEMSIZE            2296
#if !MCUCFG_MALLOCMEMSIZE
#error Ƿֵ
#endif

// </h>
///////////////////////////////////////////////////////////////////////////////

                //*** <<< end of configuration section >>> ***//

/******************************************************************************
 *                               OS Definitions                               *
 ******************************************************************************/

/* Header */
#include <string.h>
#include <intrins.h>
#include MCUCFG_STANDARDHEAD
#include "..\System\vardef.h"

/* Memory */
#define _CODE_MEM_    code
#define _SYS_MEM_     data
#define _SV_MEM_
#define _CONST_MEM_
#ifndef _MALLOC_MEM_
#define _MALLOC_MEM_  far
#endif
#if SYSCFG_TASKCREATEMODE == __STATIC__ || SYSCFG_TASKCREATEMODE == __BALANCE__
#define _THDL_MEM_    _MALLOC_MEM_
#elif SYSCFG_TASKCREATEMODE == __DYNAMIC__
#define _THDL_MEM_    _TASK_MEM_
#endif

/* Register */
#define _SYS_REG_
#define _DEBUG_HREG_
#define _DEBUG_LREG_

/* Typedef */
typedef bit   tBIT;
typedef u16   tSP;
typedef u16   tStackSize;
#if SYSCFG_CODEROMSIZE == 0
typedef u16   tPSP;
#else
typedef u32   tPSP;
#endif
typedef u8    tDM;
typedef u32   tPC;
typedef u32   tGRP;
typedef u32   tSysTick;

/* Extern */
extern bit vISV_FF;
extern u32 _SYS_MEM_ vPSP;
extern tSP _SYS_MEM_ vMSP;
extern tSP _SYS_MEM_ vBSP;
extern void _SV_MEM_ * _TASK_MEM_ vISS[MCUCFG_ISVTOTAL];
extern void __entry_monitor(void);

/* * */
#define MCUCFG_MCUARC         !__ARM__
#define MCUCFG_MCULEVEL       __ZHENGJINGPAOZI__
#define __C51USING__
#define __STK_ATTRIBUTE__     interrupt 1 __USING__
#define __PSV_ATTRIBUTE__     interrupt MCUCFG_PSVIRQ __USING__
#define __REENTRANT__         reentrant
#define __BSP_ALIGN__
#define MCUCFG_DIRMSGTYPE     0
#define __DM_PSP__
#define __DM_SIZE__           (&mx - &m0 - 1)
#if SYSCFG_DIRMSGMODE == __PERFORMANCE__
#define __DM_VAR__            tDM m0_
#define __DM_VAL__            1
#elif SYSCFG_DIRMSGMODE == __INTELLIGENT__
#define __DM_VAR__            u32 DR0_, u32 DR4_, tDM R11_, tDM m0_
#define __DM_VAL__            0, 0, 0, 1
#endif

/* API */
#define mSysTick_InitValue    (65536 - (1UL * MCUCFG_SYSFOSC * SYSCFG_STKCYCLE) / MCUCFG_SYSFOSCDIV / 12)
#define mSysTick_Cycle        (65536 - mSysTick_InitValue)
#define mSysTick_Counter      ((TH0 << 8) | TL0)
#define mSTK_Disable          ET0 = 0
#define mSTK_Enable           ET0 = 1

#define mDisableIRQ	EA = 0
#define mEnableIRQ	EA = 1

#define mEnterCritical	\
do{	\
	mPSV_Disable;	\
	mSTK_Disable;	\
}while(false)

#define mExitCritical	\
do{	\
	mSTK_Enable;	\
	mPSV_Enable;	\
}while(false)

#define mSys_Idle	\
do{	\
	PCON |= 0x01;	\
	OS_NOPxX;	\
}while(false)

#define mSys_init	\
do{	\
	__init_mempool((void _MALLOC_MEM_ *)MCUCFG_MALLOCMEMBPTR, MCUCFG_MALLOCMEMSIZE);	\
	OS_NOPx1;	\
	TMOD &= 0xF0;	\
	TL0 = (u8)(mSysTick_InitValue);	\
	TH0 = (u8)(mSysTick_InitValue >> 8);	\
	TR0 = 1;	\
	mSTK_Enable;	\
	mPSV_Enable;	\
	EA = 1;	\
}while(false)

#define mTaskmgr_Counting	\
	counter2 = (counter1 * 100 * 12 * MCUCFG_SYSFOSCDIV) / MCUCFG_SYSFOSC / counter2

#define mSTK_Counting	\
do{	\
	if(mSysTick_Counter <= tick_temp) break;	\
	vSTK_Counter1 += mSysTick_Counter - tick_temp;	\
	vSTK_Counter2++;	\
}while(false)

#if SYSCFG_TASKPCMONITOR == __ENABLED__
#define mTaskPC_Monitor	\
do{	\
	if(!vTaskmgrBinary) break;	\
	vPSP -= (__BASICSTACKSIZE__ - 1);	\
	vPC = *(tPC *)vPSP;	\
	vPC = ((u16)vPC << 8) | ((u16)vPC >> 8) | (vPC & 0xFFFF0000);	\
}while(false)
#else
#define mTaskPC_Monitor do{}while(false)
#endif

#define mUsedTime_END	\
do{	\
	if(usedtime[0])	\
	{	\
		usedtime[0]--;	\
		usedtime[1] = 65536 - usedtime[1] + counter - mSysTick_InitValue;	\
	}	\
	else	\
	{	\
		if(counter >= usedtime[1])	\
		{	\
			usedtime[1] = counter - usedtime[1];	\
		}	\
		else	\
		{	\
			usedtime[1] = 65536 - usedtime[1] + counter - mSysTick_InitValue;	\
		}	\
	}	\
	vTASKING->usedtime[0] += usedtime[0];	\
	vTASKING->usedtime[0] += (vTASKING->usedtime[1] + usedtime[1]) / mSysTick_Cycle;	\
	vTASKING->usedtime[1]  = (vTASKING->usedtime[1] + usedtime[1]) % mSysTick_Cycle;	\
}while(false)

#define mUsedTime_INIT	\
do{	\
	usedtime[0] = 0;	\
	usedtime[1] = counter;	\
}while(false)

#define mISV_Do(svid)	\
do{	\
	extern bit vISV_F##svid;	\
	vISS[svid] = &isv_;	\
	vISV_F##svid = true;	\
	vISV_FF = true;	\
	mPSV_Trigger;	\
}while(false)

#define mISV	\
	extern void __isv_handler(void);	\
	mPSV_Clear;	\
	if(vISV_FF) __isv_handler();	\
	if(!vScheduling_f) return

#define miWriteFlagBits	\
	static bit flag = false;	\
	if(!flag)	\
	{	\
		flag = true



/*
 * MSPģʽ
 */

#if MCUCFG_TASKSTACKMODE == __MSP__

/* * */
#define MCUCFG_TASKSTACKMONITOR __DISABLED__
#if MCUCFG_STKREGBANK
#define __USING__               using MCUCFG_STKREGBANK
#define __REGSIZE__             8
#define __BASICSTACKSIZE__      (32 - SYSCFG_4BYTEINTFRAME)
#else
#define __USING__
#define __REGSIZE__             0
#define __BASICSTACKSIZE__      (40 - SYSCFG_4BYTEINTFRAME)
#endif
#define __STACKSIZE_TASKMGR__   (__BASICSTACKSIZE__ + 16)
#define __STACKSIZE_DEBUGGER__  (__BASICSTACKSIZE__ + 16)
#define __STACKSIZE_STARTER__   (__BASICSTACKSIZE__ + 16)
#define __STACKSIZE_SYSIDLE__   (__BASICSTACKSIZE__ + 16)

/* API */
#define mTaskNode_Head_       tStackSize stacklen;
#if __REGSIZE__
#define mTaskNode_Tail_       u8 reg[__REGSIZE__];
#define mReg_PUSH	\
	*(u32 *)(vTASKING->reg + 0) = *(u32 _SYS_MEM_ *)0;	\
	*(u32 *)(vTASKING->reg + 4) = *(u32 _SYS_MEM_ *)4
#define mReg_POP	\
	*(u32 _SYS_MEM_ *)0 = *(u32 *)(vTASKING->reg + 0);	\
	*(u32 _SYS_MEM_ *)4 = *(u32 *)(vTASKING->reg + 4)
#else
#define mTaskNode_Tail_
#define mReg_PUSH do{}while(false)
#define mReg_POP  do{}while(false)
#endif

#define mSys_INIT	\
do{	\
	vMSP = (SPH << 8) | SP;	\
	vBSP = vMSP + 1;	\
	mSys_init;	\
}while(false)

#define mScheduler_INIT	\
	u8  i;	\
	u8  _STACK_MEM_  * _SYS_REG_ msp8;	\
	u8  _MALLOC_MEM_ * _SYS_REG_ psp8;	\
	u32 _STACK_MEM_  * _SYS_REG_ msp32;	\
	u32 _MALLOC_MEM_ * _SYS_REG_ psp32;	\
	bit vPUSH_f = false;	\
	vScheduling_f = false;	\
	__asm{MOV vPSP, DR60}

#define mTaskStack_INIT	\
do{	\
	*(u32 *)node_news->BSP = ((u16)vACTBUF->entry << 8) | ((u16)vACTBUF->entry >> 8) | ((u32)vACTBUF->entry & 0xFFFF0000);	\
	*(u8 *)(node_news->BSP + __BASICSTACKSIZE__ - 3) = 0;	\
	node_news->stacklen = __BASICSTACKSIZE__;	\
}while(false)

#define mTaskStack_LEN	\
	stacklen = (tSP)vPSP - vMSP

#define mEvery_Monitor do{}while(false)
#define mEntry_Monitor do{}while(false)

#if SYSCFG_TASKCREATEMODE == __STATIC__
#define mPUSH_Monitor	\
do{	\
	if(vTASKING->stacksize < stacklen)	\
	{	\
		vTASKING->state = __STOPPED_TSOF__;	\
		vFault.overflow_taskstack = true;	\
	}	\
	else	\
	{	\
		vPUSH_f = true;	\
		if(vTASKING->TPL > node_news->TPL)	\
		{	\
			vTASKING->counter = 0;	\
		}	\
	}	\
}while(false)
#else
#define mPUSH_Monitor	\
do{	\
	if(vTASKING->stacksize < stacklen)	\
	{	\
		vTASKING->stacksize = stacklen;	\
		__free(vTASKING->BSP);	\
		vTASKING->BSP = NULL;	\
		vTASKING->BSP = (u8 *)__malloc(vTASKING->stacksize);	\
		if(vTASKING->BSP != NULL)	\
		{	\
			vTASKING->realloc = true;	\
			vAlarm.realloc_taskstack = true;	\
			vPUSH_f = true;	\
		}	\
		else	\
		{	\
			vTASKING->state = __STOPPED_TSRF__;	\
			vFault.reallocfail_taskstack = true;	\
		}	\
	}	\
	else	\
	{	\
		vPUSH_f = true;	\
	}	\
	if(vPUSH_f)	\
	{	\
		if(vTASKING->TPL > node_news->TPL)	\
		{	\
			vTASKING->counter = 0;	\
		}	\
	}	\
}while(false)
#endif

#define mTaskStack_PUSH	\
do{	\
	if(!vPUSH_f) break;	\
	if(vTaskmgrBinary) mUsedTime_END;	\
	msp32 = (u32 _STACK_MEM_  *)vBSP;	\
	psp32 = (u32 _MALLOC_MEM_ *)vTASKING->BSP;	\
	vTASKING->stacklen = stacklen;	\
	i = stacklen >> 2;	\
	do{	\
		*psp32++ = *msp32++;	\
	}while(--i);	\
	i = stacklen & 3;	\
	if(i)	\
	{	\
		msp8 = (u8 _STACK_MEM_  *)msp32;	\
		psp8 = (u8 _MALLOC_MEM_ *)psp32;	\
		do{	\
			*psp8++ = *msp8++;	\
		}while(--i);	\
	}	\
	mReg_PUSH;	\
	mTaskPC_Monitor;	\
}while(false)

#define mTaskStack_POP	\
do{	\
	if(vTaskmgrBinary) mUsedTime_INIT;	\
	vTASKING = node_news;	\
	msp32 = (u32 _STACK_MEM_  *)vBSP;	\
	psp32 = (u32 _MALLOC_MEM_ *)vTASKING->BSP;	\
	stacklen = vTASKING->stacklen;	\
	i = stacklen >> 2;	\
	do{	\
		*msp32++ = *psp32++;	\
	}while(--i);	\
	i = stacklen & 3;	\
	if(i)	\
	{	\
		msp8 = (u8 _STACK_MEM_  *)msp32;	\
		psp8 = (u8 _MALLOC_MEM_ *)psp32;	\
		do{	\
			*msp8++ = *psp8++;	\
		}while(--i);	\
	}	\
	mReg_POP;	\
	vPSP = vMSP + stacklen;	\
	__asm{MOV DR60, vPSP};	\
}while(false)



/*
 * MSP+PSPģʽ
 */

#elif MCUCFG_TASKSTACKMODE == __MSP_PSP__

/* * */
#define __USING__
#define __BASICSTACKSIZE__    (40 - SYSCFG_4BYTEINTFRAME)

/* API */
#define mTaskNode_Head_       tPSP PSP;
#define mTaskNode_Tail_

#define mSys_INIT	\
do{	\
	vMSP = (SPH << 8) | SP;	\
	mSys_init;	\
}while(false)

#define mScheduler_INIT	\
	bit vPUSH_f = false;	\
	vScheduling_f = false;	\
	__asm{MOV vPSP, DR60}

#define mTaskStack_INIT	\
do{	\
	*(u32 *)node_news->BSP = ((u16)vACTBUF->entry << 8) | ((u16)vACTBUF->entry >> 8) | ((u32)vACTBUF->entry & 0xFFFF0000);	\
	*(u8 *)(node_news->BSP + __BASICSTACKSIZE__ - 3) = 0;	\
	node_news->PSP = (tSP)node_news->BSP + __BASICSTACKSIZE__ - 1;	\
}while(false)

#define mTaskStack_LEN	\
	stacklen = (tSP)vPSP + 1 - (tSP)vTASKING->BSP

#if MCUCFG_TASKSTACKMONITOR == __ENABLED__
#define mEvery_Monitor	\
do{	\
	if(vTASKING->state == __STOPPED_TSOF__)	\
	{	\
		vFault.overflow_taskstack = true;	\
	}	\
	else if(vTASKING->stacksize < stacklen)	\
	{	\
		vTASKING->state = __STOPPED_TSOF__;	\
		vFault.overflow_taskstack = true;	\
	}	\
}while(false)
#define mEntry_Monitor __entry_monitor()
#else
#define mEvery_Monitor do{}while(false)
#define mEntry_Monitor do{}while(false)
#endif

#define mPUSH_Monitor	\
do{	\
	vPUSH_f = true;	\
	if(vTASKING->TPL > node_news->TPL)	\
	{	\
		vTASKING->counter = 0;	\
	}	\
}while(false)

#define mTaskStack_PUSH	\
do{	\
	if(!vPUSH_f) break;	\
	if(vTaskmgrBinary) mUsedTime_END;	\
	vTASKING->PSP = vPSP;	\
	mTaskPC_Monitor;	\
}while(false)

#define mTaskStack_POP	\
do{	\
	if(vTaskmgrBinary) mUsedTime_INIT;	\
	vTASKING = node_news;	\
	vPSP = vTASKING->PSP;	\
	__asm{MOV DR60, vPSP};	\
}while(false)

#endif

#endif
